/* Copyright 2006 Nicholas Bishop
 * 
 * This file is part of SharpConstruct.
 *
 * SharpConstruct is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SharpConstruct is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SharpConstruct; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef DISPLACEBRUSH_HH
#define DISPLACEBRUSH_HH

#include "Brush.hh"
#include "Sculpt.hh"
#include <vector>

namespace SharpConstruct
{
	namespace Brush
	{
		class Displace : public BrushBase
		{
		public:
			virtual SupportedProperties Properties() const;
		protected:
			virtual float factor_() const;

			virtual void pre_start_sculpt_();
			virtual void start_sculpt_( const EditData& );

			virtual void pre_continue_sculpt_();
			virtual void continue_sculpt_( const EditData& );
		private:
			void mask_();
			void simple_displace_( const EditData& );
			void layer_displace_( const EditData& );
			
			std::vector< ActiveData > active_data_;
			std::vector< float > displacements_;
			std::vector< float > color_adds_;
		};
	}
}

#endif
