/* Copyright 2006 Nicholas Bishop
 * 
 * This file is part of SharpConstruct.
 *
 * SharpConstruct is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SharpConstruct is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SharpConstruct; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include "Mesh.hh"
#include <fstream>

namespace SharpConstruct
{
	class SaveLWO
	{
	public:
		SaveLWO( Mesh&, const std::string& );
	private:
		typedef std::vector< char > Data;

		void write_data_( Data );

		template< typename T >
		void write_( const T t )
		{
			Data data( sizeof( T ) );
			for( unsigned i = 0; i < sizeof( T ); ++i )
				data[ i ] = ( ( char* )( &t ) )[ i ];
			write_data_( data );
		}

		void write_ux_( const unsigned );
		void write_chunk_( const std::string& );
		void write_string_( const std::string& );

		Mesh& mesh_;
		std::ofstream file_;
		unsigned length_;
	};
}
